register_check_parameters(
    subgroup_storage,
    "nfsiostats",
    _("NFS IO Statistics"),
    Dictionary(
       title=_("NFS IO Statistics"),
       optional_keys=True, 
       elements=[
        ("op_s",
            Tuple(
             title=_("Operations"),
             elements=[
               Float(title=_("Warning at"), default_value=70.00, unit="1/s"),
               Float(title=_("Critical at"), default_value=100.00, unit="1/s"),
            ])),
        ("rpc_backlog",
            Tuple(
             title=_("RPC Backlog"),
             elements=[
               Float(title=_("Warning below"), default_value=70.00, unit="queue"),
               Float(title=_("Critical below"), default_value=100.00, unit="queue"),
            ])),
        ("read_ops",
            Tuple(
             title=_("Read Operations"),
             elements=[
               Float(title=_("Warning at"), default_value=150.000, unit="1/s"),
               Float(title=_("Critical at"), default_value=200.000, unit="1/s"),
            ])),
        ("read_b_s",
            Tuple(
             title=_("Read Bytes"),
             elements=[
               Float(title=_("Warning at"), default_value=200.000, unit="bytes/s"),
               Float(title=_("Critical at"), default_value=250.000, unit="bytes/s"),
            ])),
        ("read_b_op",
            Tuple(
             title=_("Read kB/op"),
             elements=[
               Float(title=_("Warning at"), default_value=200.000, unit="bytes/op"),
               Float(title=_("Critical at"), default_value=250.000, unit="bytes/op"),
            ])),
        ("read_retrans",
            Tuple(
             title=_("Read Retransmissions"),
             elements=[
               Percentage(title=_("Warning at"), default_value=10.0),
               Percentage(title=_("Critical at"), default_value=20.0),
            ])),
        ("read_avg_rtt_ms",
            Tuple(
             title=_("Read Average RTT (ms)"),
             elements=[
               Float(title=_("Warning at"), default_value=150.000, unit="ms"),
               Float(title=_("Critical at"), default_value=200.000, unit="ms"),
            ])),
        ("read_avg_exe_ms",
            Tuple(
             title=_("Read Average Executions (ms)"),
             elements=[
               Float(title=_("Warning at"), default_value=15.000, unit="ms"),
               Float(title=_("Critical at"), default_value=16.000, unit="ms"),
            ])),
        ("write_ops_s",
            Tuple(
             title=_("Write Operations/s"),
             elements=[
               Float(title=_("Warning at"), default_value=15.000, unit="1/s"),
               Float(title=_("Critical at"), default_value=16.000, unit="1/s"),
            ])),
        ("write_b_s",
            Tuple(
             title=_("Write Bytes"),
             elements=[
               Float(title=_("Warning at"), default_value=200.000, unit="bytes/s"),
               Float(title=_("Critical at"), default_value=250.000, unit="bytes/s"),
            ])),
        ("write_b_op",
            Tuple(
             title=_("Write B/s"),
             elements=[
               Float(title=_("Warning at"), default_value=200.000, unit="bytes/s"),
               Float(title=_("Critical at"), default_value=250.000, unit="bytes/s"),
            ])),
        ("write_retrans",
            Tuple(
             title=_("Write Retransmissions"),
             elements=[
               Percentage(title=_("Warning at"), default_value=10.0),
               Percentage(title=_("Critical at"), default_value=20.0),
            ])),
        ("write_avg_rtt_ms",
            Tuple(
             title=_("Write Avg RTT (ms)"),
             elements=[
               Float(title=_("Warning at"), default_value=10.000, unit="ms"),
               Float(title=_("Critical at"), default_value=20.000, unit="ms"),
            ])),
        ("write_avg_exe_ms",
            Tuple(
             title=_("Write Avg exe (ms)"),
             elements=[
               Float(title=_("Warning at"), default_value=10.000, unit="ms"),
               Float(title=_("Critical at"), default_value=20.000, unit="ms"),
            ])),
       ]
   ),

    TextAscii(
        title=_("NFS IO Statistics"),
    ),
    match_type="dict",
)